/*
 * run with jahob.opt -method EvenMult.multByThree EvenMult.java -usedp cvcl
 */
class EvenMult {
    static int multByThree(int n)
    /*: requires "n >= 0"
        ensures  "result div 2 = 0" */
    {
	return n * 3;
    }

    static int id(int x)
    /*: requires "x >= 0"
        ensures "(result = 0 | result = 1) & ((result < 5) --> False)" */
    {
	return x;
    }

    static int twovars(int x, int y)
    /*: requires "x >= 0 & y >= 0"
      ensures  "result > 0" */
    {
	return x + y;
    }

    static int trivial(int x, int y)
    /*: requires "x >= 0 & y >= 0"
        ensures "result = 0" */
    {
	if( x / 2 != y ) {
	    return 0;
	} else {
	    return (x - 2 * y);
	}
    }

    public static int fi3(int x, int y)
    /*: requires "x > 0 & y >= 0"
      ensures "result > 0" */
    {
        int r = 0;
        int i = y;
        while //: inv "r = (y - i)*x & i >= 0"
            (i > 0) {
            i = i - 1;
            r = r + x;
        }
        return r;
    }

    // This just to test whether modifier testing works
    public void bleh() {
    }

    // Here to see whether return and param types are checked:
    static int f1(Object o1) {
	return 23;
    }
    static Object f2(int x) {
	return new Object();
    }
}
